// Copyright (C) 2006 Institut fuer Telematik, Universitaet Karlsruhe (TH)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**
 * @file PeerInfo.h
 * @author Helge Backhaus
 */

#include "PeerInfo.h"

PeerInfo::PeerInfo(int moduleId)
{
    bootstrapped = false;
    this->moduleId = moduleId;
}

//public
bool PeerInfo::isMalicious()
{
    BaseOverlay* overlay = dynamic_cast<BaseOverlay*>(simulation.module(moduleId));
    if(overlay==NULL)
        opp_error("Peer not associated with a BaseOverlay Module");
    return overlay->isMalicious();
}

std::ostream& operator<<(std::ostream& Stream, const PeerInfo info)
{
    Stream  << "ModuleId: " << info.moduleId << "Bootstrapped: ";
    if(info.bootstrapped) {
        return Stream << "true";
    }
    else {
        return Stream << "false";
    }
}
